Index: XIOS/dev/branch_openmp/src/transformation/Functions/reduction.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/Functions/reduction.cpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/Functions/reduction.cpp	(revision 1339)
@@ -9,5 +9,4 @@
 
 CReductionAlgorithm::CallBackMap* CReductionAlgorithm::reductionCreationCallBacks_ = 0;
-//std::map<StdString,EReductionType> CReductionAlgorithm::ReductionOperations = std::map<StdString,EReductionType>();
 std::map<StdString,EReductionType> *CReductionAlgorithm::ReductionOperations_ptr = 0;
 
@@ -52,5 +51,5 @@
 
 //bool CReductionAlgorithm::_dummyInit = CReductionAlgorithm::initReductionOperation(CReductionAlgorithm::ReductionOperations);
-bool CReductionAlgorithm::_dummyInit = CReductionAlgorithm::initReductionOperation();
+//bool CReductionAlgorithm::_dummyInit = CReductionAlgorithm::initReductionOperation();
 
 CReductionAlgorithm* CReductionAlgorithm::createOperation(EReductionType reduceType)
Index: XIOS/dev/branch_openmp/src/transformation/Functions/reduction.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/Functions/reduction.hpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/Functions/reduction.hpp	(revision 1339)
@@ -16,5 +16,5 @@
 namespace xios {
 
-/*!
+/*!  
   \class CReductionAlgorithm
   Interface for all reduction alogrithms.
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.cpp	(revision 1339)
@@ -13,5 +13,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-#include "reduction.hpp"
 
 namespace xios {
@@ -62,5 +61,8 @@
 
   pos_ = algo->position;
-  //reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  if(CReductionAlgorithm::ReductionOperations_ptr == 0) 
+  {
+    CReductionAlgorithm::initReductionOperation();
+  }
   reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations_ptr->at(op));
 }
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1339)
@@ -13,4 +13,5 @@
 #include "transformation.hpp"
 
+#include "reduction.hpp"
 namespace xios {
 
@@ -25,5 +26,5 @@
   Extract a domain to an axis
 */
-class CAxisAlgorithmExtractDomain : public CAxisAlgorithmTransformation
+class CAxisAlgorithmExtractDomain : public CAxisAlgorithmTransformation, public CReductionAlgorithm
 {
 public:
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.cpp	(revision 1339)
@@ -13,5 +13,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-#include "reduction.hpp"
 
 namespace xios {
@@ -70,5 +69,8 @@
 
   dir_ = (CReduceDomainToAxis::direction_attr::iDir == algo->direction)  ? iDir : jDir;
-  //reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  if(CReductionAlgorithm::ReductionOperations_ptr == 0) 
+  {
+    CReductionAlgorithm::initReductionOperation();
+  }
   reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations_ptr->at(op));
 }
Index: XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1339)
@@ -12,4 +12,5 @@
 #include "axis_algorithm_transformation.hpp"
 #include "transformation.hpp"
+#include "reduction.hpp"
 
 namespace xios {
@@ -24,5 +25,5 @@
   Reduce a domain to an axis
 */
-class CAxisAlgorithmReduceDomain : public CAxisAlgorithmTransformation
+class CAxisAlgorithmReduceDomain : public CAxisAlgorithmTransformation, public CReductionAlgorithm
 {
 public:
Index: XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_extract_axis.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_extract_axis.cpp	(revision 1339)
@@ -14,5 +14,4 @@
 #include "grid_transformation_factory_impl.hpp"
 
-#include "reduction.hpp"
 
 namespace xios {
@@ -49,5 +48,8 @@
   StdString op = "extract";
   pos_ = algo->position;
-  //reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
+  if(CReductionAlgorithm::ReductionOperations_ptr == 0) 
+  {
+    CReductionAlgorithm::initReductionOperation();
+  }
   reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations_ptr->at(op));
 }
Index: XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_extract_axis.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1339)
@@ -12,4 +12,5 @@
 #include "scalar_algorithm_transformation.hpp"
 #include "transformation.hpp"
+#include "reduction.hpp"
 
 namespace xios {
@@ -24,5 +25,5 @@
   Extract a scalar from an axis
 */
-class CScalarAlgorithmExtractAxis : public CScalarAlgorithmTransformation
+class CScalarAlgorithmExtractAxis : public CScalarAlgorithmTransformation, public CReductionAlgorithm
 {
 public:
Index: XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1339)
@@ -13,5 +13,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-#include "reduction.hpp"
 
 namespace xios {
@@ -73,6 +72,11 @@
   }
   
+  if(CReductionAlgorithm::ReductionOperations_ptr == 0) 
+  {
+    CReductionAlgorithm::initReductionOperation();
+  }
+  
   //if (CReductionAlgorithm::ReductionOperations.end() == CReductionAlgorithm::ReductionOperations.find(op))
-  if (CReductionAlgorithm::ReductionOperations_ptr->end() == CReductionAlgorithm::ReductionOperations_ptr->find(op))
+  if ((*CReductionAlgorithm::ReductionOperations_ptr).end() == (*CReductionAlgorithm::ReductionOperations_ptr).find(op))
     ERROR("CScalarAlgorithmReduceAxis::CScalarAlgorithmReduceAxis(CAxis* axisDestination, CAxis* axisSource, CReduceAxisToScalar* algo)",
        << "Operation '" << op << "' not found. Please make sure to use a supported one"
@@ -81,5 +85,5 @@
 
   //reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations[op]);
-  reduction_ = CReductionAlgorithm::createOperation(CReductionAlgorithm::ReductionOperations_ptr->at(op));
+  reduction_ = CReductionAlgorithm::createOperation((*CReductionAlgorithm::ReductionOperations_ptr)[op]);
 }
 
Index: XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_axis.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1339)
@@ -12,4 +12,5 @@
 #include "scalar_algorithm_transformation.hpp"
 #include "transformation.hpp"
+#include "reduction.hpp"
 
 namespace xios {
@@ -24,5 +25,5 @@
   Reducing an axis to a scalar
 */
-class CScalarAlgorithmReduceAxis : public CScalarAlgorithmTransformation
+class CScalarAlgorithmReduceAxis : public CScalarAlgorithmTransformation, public CReductionAlgorithm
 {
 public:
Index: XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_domain.cpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_domain.cpp	(revision 1339)
@@ -14,5 +14,4 @@
 #include "grid_transformation_factory_impl.hpp"
 
-#include "reduction.hpp"
 
 namespace xios {
@@ -69,6 +68,8 @@
   }
   
-  // if(CReductionAlgorithm::ReductionOperations_ptr == 0) 
-  //   CReductionAlgorithm::initReductionOperation();
+  if(CReductionAlgorithm::ReductionOperations_ptr == 0) 
+  {
+    CReductionAlgorithm::initReductionOperation();
+  }
 
   //if (CReductionAlgorithm::ReductionOperations.end() == CReductionAlgorithm::ReductionOperations.find(op))
Index: XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_domain.hpp
===================================================================
--- XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1338)
+++ XIOS/dev/branch_openmp/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1339)
@@ -12,4 +12,5 @@
 #include "scalar_algorithm_transformation.hpp"
 #include "transformation.hpp"
+#include "reduction.hpp"
 
 namespace xios {
@@ -24,5 +25,5 @@
   Reducing an DOMAIN to a scalar
 */
-class CScalarAlgorithmReduceDomain : public CScalarAlgorithmTransformation
+class CScalarAlgorithmReduceDomain : public CScalarAlgorithmTransformation, public CReductionAlgorithm
 {
 public: